Bug 719938 - Add support for Kerberos ticket delegation
Add support for Kerberos ticket delegation
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: curl (Show other bugs)
6.1
All Linux
urgent Severity urgent
: rc
: ---
Assigned To: Kamil Dudka
Miroslav Vadkerti
: Regression, ZStream
Depends On:
Blocks: 719945 723643 723645 727882
  Show dependency treegraph
 
Reported: 2011-07-08 09:14 EDT by Rob Crittenden
Modified: 2013-02-21 05:09 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
As a solution to a security issue, GSSAPI credential delegation was disabled, which broke the functionality of the applications that were relying on delegation, which was incorrectly enabled by libcurl. To fix this issue, the CURLOPT_GSSAPI_DELEGATION libcurl option has been introduced in order to enable delegation explicitly when applications need it. All applications using GSSAPI credential delegation can now use this new libcurl option to be able to run properly.
Story Points: ---
Clone Of:
: 723643 (view as bug list)
Environment:
Last Closed: 2013-02-21 05:09:10 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
el6 backport of the upstream patches (12.38 KB, patch)
2011-08-03 07:14 EDT, Kamil Dudka
praiskup: review+
Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Knowledge Base (Legacy) 60427 None None None Never

  None (edit)
Description Rob Crittenden 2011-07-08 09:14:43 EDT
Description of problem:

libcurl upstream dropped support for delegating Kerberos tickets. This was applied to EL6 in bug https://bugzilla.redhat.com/show_bug.cgi?id=711454

The IPA project needs to be able to delegate tickets via XML-RPC (we use the xmlrpc-c package which in turn uses libcurl).

This also affects certmonger which uses similar xmlrpc-c/libcurl calls to communicate with IPA.

Version-Release number of selected component (if applicable):

curl-7.19.7-26.el6_1.1

Steps to Reproduce:
1. Install an IPA server
2. On a separate machine run: ipa-client-install using details from step 1
  
Actual results:

Joining realm failed because of failing XML-RPC request.
   This error may be caused by incompatible server/client major versions.

On the Apache server if you set LogLevel debug in nss.conf you'll see that the ticket was not delegated.
Comment 3 Kamil Dudka 2011-07-08 18:50:43 EDT
I have proposed a solution upstream:

http://thread.gmane.org/gmane.comp.web.curl.general/12226/focus=32265

Whoever is going to commit the fix, please just make sure we use the same option name/constant as upstream.  Otherwise we would have incompatible API/ABI.  Thanks in advance!
Comment 4 Adam Tkac 2011-07-20 08:13:29 EDT
I sent improved patch to upstream:

http://permalink.gmane.org/gmane.comp.web.curl.library/32355

and I'm currently waiting for response.
Comment 6 Kamil Dudka 2011-07-25 06:43:56 EDT
Upstream requests to take RFC 5896 into consideration:

http://tools.ietf.org/html/rfc5896

I have proposed an incremental patch addressing this request:

http://thread.gmane.org/gmane.comp.web.curl.library/32355/focus=32374
Comment 7 Kamil Dudka 2011-07-28 07:08:37 EDT
A new version of the patch reflecting Julien Chaffraix's review comments:

http://thread.gmane.org/gmane.comp.web.curl.library/32355/focus=32419
Comment 8 Kamil Dudka 2011-08-03 05:17:39 EDT
upstream commit:

https://github.com/bagder/curl/compare/7688a99bef...a7864c41db
Comment 11 Kamil Dudka 2011-08-03 07:14:40 EDT
Created attachment 516492 [details]
el6 backport of the upstream patches
Comment 15 Miroslav Svoboda 2011-08-10 12:14:38 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
As a solution to a security issue, GSSAPI credential delegation was disabled, which broke the functionality of the applications that were relying on delegation, which was incorrectly enabled by libcurl. To fix this issue, the CURLOPT_GSSAPI_DELEGATION libcurl option has been introduced in order to enable delegation explicitly when applications need it. All applications using GSSAPI credential delegation can now use this new libcurl option to be able to run properly.
Comment 21 errata-xmlrpc 2013-02-21 05:09:10 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2013-0393.html

Note You need to log in before you can comment on or make changes to this bug.